package Jcg.closestpair;

import Jcg.geometry.*;

/**
 * Implementation of a quadratic time algorithm for computing the closest pair,
 * based on exhaustive search.
 *
 * @author Code by Luca Castelli Aleardi (INF562, Ecole Polytechnique)
 *
 */
public class SlowClosestPair implements ClosestPair {
	
    public PointPair_2 findClosestPair(Point_2[] points) {
		if(points.length<2) throw new Error("Error: too few points");
		
		PointPair_2 result=new PointPair_2(points[0], points[1]);
		PointPair_2 pair;
		double distance=result.distance();
		for(int i=0;i<points.length;i++) {
			for(int j=i+1;j<points.length;j++) {
				double pairDistance=points[i].distanceFrom(points[j]).doubleValue();
				pair=new PointPair_2(points[i], points[j]);
				if(pairDistance<distance) {
					result=pair;
					distance=pairDistance;
				}
			}
		}
		return result;			
    }

}