package Jcg.convexhull2d;

import Jcg.geometry.*;

/**
 * Interface defining methods for the computation of the convex hull of points on the plane
 *
 * @author Luca Castelli Aleardi, Ecole Polytechnique (INF562)
 * @version feb 2014
 */
public interface ConvexHull_2 {
    
	/**
	 * Computation of 2D convex hull
	 * 
	 * @param points the input point cloud (stored as an array list)
	 * @return the (ordered) list of points on the boundary of the convex hull
	 */
    public PointCloud_2 computeConvexHull(PointCloud_2 points);

}
