package Jcg.convexhull3d;

import java.util.Collection;

import Jcg.geometry.*;

/**
 * Interface defining methods for the computation of the convex hull of points in 3D space
 *
 * @author Luca Castelli Aleardi, Ecole Polytechnique (INF562)
 * @version feb 2014
 */
public interface ConvexHull_3 {
    
	/**
	 * Computation of 3D convex hull
	 * 
	 * @param points the input 3D point cloud (stored as an array list)
	 * @return the collection of triangles on the boundary of the 3D convex hull
	 */
    public Collection<Triangle_3> computeConvexHull(PointCloud_3 points);

}
