package Jcg.graph;

import java.util.*;

/**
 * Define the abstract data type for a graph (undirected, not weighted)
 * (explicit pointer-based representation of a graph)
 *
 * @author Luca Castelli Aleardi, Ecole Polytechnique (INF562)
 * @version dec 2012
 */
public interface Graph<V extends Node> {
	
    public void addEdge(V d, V a);
    public void removeEdge(V d, V a);
    public void addNode(V v);
    public void removeNode(V v);
    
    public boolean adjacent(V d, V a);
    public int degree(V v);
    public Collection<V> getNeighbors(V v);
    
    public int sizeVertices();
}
