package Jcg.rangesearch;

import Jcg.geometry.Point_3;
import Jcg.geometry.PointCloud_3;

/**
 * Define methods for range search queries in 3D
 * 
 * @author Luca Castelli Aleardi (Ecole Polytechnique, INF562)
 * @version jan 2014
 */
public interface RangeSearch_3 {

    /**
     * Compute the points at distance at most delta from q.
     * 
     * @param q the query point
     * @param delta the range distance
     * @return the set of points at distance at most delta from q.
     */    
    public PointCloud_3 rangeSearch (Point_3 q, double delta);

}
