package Jcg.schnyderwoods;

import java.util.Arrays;

public class Util {

	public static double approx(double x, int prec) {
		double p=(int)Math.pow(10, prec);
		return ((int)(x*p))/p;
	}

	public static void percentile(double[] t) {
		Arrays.sort(t);
		
		double min=approx(t[1], 4);
		double max=approx(t[t.length-1], 4);
		
		double p25=approx(t[(int)(t.length*0.25)], 4);
		double p75=approx(t[(int)(t.length*0.75)], 4);
		
		System.out.println("min\t25prec\t75perc\tmax");
		System.out.println(""+min+"\t"+p25+"\t"+p75+"\t"+max);
		System.out.println("\t"+approx((max+min)/2., 3)+" 0 "+approx((max-min)/2., 3));
		System.out.println("\t"+approx((p75+p25)/2., 3)+" 0 "+approx((p75-p25)/2., 3));
	}

	public static void stats(double[] t, String s) {
		Arrays.sort(t);
		
		double min=approx(t[1], 4);
		double max=approx(t[t.length-1], 4);
		
		double median=approx(t[(int)(t.length*0.5)], 4);
		
		System.out.println(s);
		System.out.println("\tNumber of tests: "+t.length);
		System.out.println("\tminimum="+min);
		System.out.println("\tmaximum="+max);
		System.out.println("\tmedian="+median);
	}

}
