package Jcg.simplification;

import Jcg.geometry.Point_3;
import Jcg.polyhedron.*;

/**
 * Abstract class defining methods for performing mesh simplification (via incremental edge decimation)
 * 
 * @author Luca Castelli Aleardi
 *
 */
public abstract class MeshSimplification {

	public Polyhedron_3<Point_3> polyhedron3D;
	
	public MeshSimplification(Polyhedron_3<Point_3> polyhedron3D) {
		this.polyhedron3D=polyhedron3D;
	}

	/**
	 * The main method performing the simplification process
	 * 
	 * @param ratio  the proportion of edges to be simplified (a real number in [0..1])
	 */
	public abstract void simplify(double ratio);

}
