package Jcg.test;
import processing.core.*;

import Jcg.geometry.*;
import Jcg.simplification.EdgeContraction;
import Jcg.simplification.MeshSimplification;
import Jcg.subdivision.CatmullClarkSubdivision;
import Jcg.subdivision.LoopSubdivision;
import Jcg.subdivision.MeshSubdivision;
import Jcg.viewer.processing3d.DrawPolyhedronProcessing;
import Jcg.viewer.processing3d.MeshViewerProcessing;

/**
 * A simple PApplet for testing mesh simplification algorithms based on edge collapse
 * 
 * @author Luca Castelli Aleardi (INF555/562, 2012-19)
 *
 */
public class TestSimplification extends MeshViewerProcessing {
	
	public MeshSimplification edgeCollapse;
	public MeshSimplification quadricErrorMetric;
	
	/**
	 * Initialize the basic parameters of the viewer
	 */
	public void setup() {
		super.setup(); // set the arcball, 3D rendering mode and window size  
		  
		this.drawingMethod=new DrawPolyhedronProcessing(this, filename);
		this.zoomFactor=this.drawingMethod.computeScaleFactor();
		
		this.edgeCollapse=new EdgeContraction(this.drawingMethod.polyhedron3D);
	}
		 		
	/**
	 * Select the action to perform
	 */
		public void keyPressed(){
			  switch(key) {
			    case('e'):case('E'): this.simplify(); break;
			    case('r'):this.renderType=(this.renderType+1)%this.renderModes; break;
			    case('+'):this.zoomIn(); break;
			    case('-'):this.zoomOut(); break;
			  }
		}
		
		/**
		 * Perform an iteration of the subdivision
		 */
		public void simplify() {
			this.edgeCollapse.simplify(0.05); // perform the decimation of 5% of edges
			this.drawingMethod.polyhedron3D.isValid(false);
		}
		
		/**
		 * For running the PApplet as Java application
		 */
		public static void main(String args[]) {
			System.out.println("Testing simplification methods (edge collapse)");
	    	if (args.length == 0) {
	    		System.out.println("I wait for a mesh stored in OFF format");
	    		System.out.println("Usage : java TestSimplification filename");
	    		return;
	    	}
			TestSubdivision.filename=args[0];
			PApplet.main(new String[] { "Jcg.test.TestSimplification" });
		}
		
}
