package Jcg.viewer.editor2d;

import java.awt.Menu;
import java.awt.MenuItem;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import Jcg.geometry.*;
import Jcg.convexhull2d.*;

/**
 * Class defining menu for dealing with algorithms
 * 
 * @author Luca Castelli Aleardi, Ecole Polytechnique (INF562)
 * @version dec 2012
 *
 */
public class AlgorithmsMenu extends Menu implements ActionListener {

	  Editor2D editor;  
	  
	  public AlgorithmsMenu(Editor2D m) { 
		  super("Algorithms"); 
		  editor = m; 
		  MenuItem itemConvexHull; 
		  add(itemConvexHull = new MenuItem("Convex Hull")); 
		  itemConvexHull.addActionListener(this); 
	  } 
	 
	  public void actionPerformed(ActionEvent e) { 
		  String item = e.getActionCommand(); 
		  if (item.equals("Exit"))  
			  editor.exit(); 
		  if (item.equals("Convex Hull")) {
			  System.out.print("Computing convex hull...");
			  this.editor.canvas.algorithms.selectAlgorithm(this.editor.canvas.algorithms.CONVEX_HULL_2);
			  this.editor.canvas.algorithms.executeAlgorithm();
		  }
		  else  
			  System.out.println("Not selected algorithm" + item); 
	  }
	  
}
