package Jcg.viewer.editor2d;

import java.awt.Button;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Panel;
import java.awt.im.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * A class defining a tool bar (providing buttons)
 * 
 * @author Luca Castelli Aleardi, Ecole Polytechnique (INF562)
 * @version dec 2012
 */
public class ControlBar extends Panel implements ActionListener {

	// GUI Widgets
	Button zoomIn;
	Button zoomOut;
	Button showGrid;
	Button showBoundingBox;
	Button centerTheWindow;
	
	Canvas2D canvas;

	public ControlBar(Canvas2D canvas) {
		this.canvas=canvas;
		
		this.setBackground(Color.lightGray);
		this.setLayout(new FlowLayout(FlowLayout.LEFT));
		
		// add buttons
		zoomIn = new Button("zoom in");
		this.add(zoomIn);
		zoomIn.addActionListener(this);

		zoomOut = new Button("zoom out");
		this.add(zoomOut);
		zoomOut.addActionListener(this);

		showGrid = new Button("show grid");
		this.add(showGrid);
		showGrid.addActionListener(this);
		
		showBoundingBox = new Button("bounding box");
		this.add(showBoundingBox);
		showBoundingBox.addActionListener(this);
	}
	
	public void actionPerformed(ActionEvent e) {
		
		if (e.getSource() == zoomIn) {
			this.canvas.zoomIn();
			repaint();		// repaint this applet
			canvas.repaint();	// also repaint the canvas
		}
		if (e.getSource() == zoomOut) {
			this.canvas.zoomOut();
			repaint();		// repaint this applet
			canvas.repaint();	// also repaint the canvas
		}
		if (e.getSource() == showGrid) {
			this.canvas.showGrid=!this.canvas.showGrid;
			repaint();		// repaint this applet
			canvas.repaint();	// also repaint the canvas
		}
		if (e.getSource() == showBoundingBox) {
			this.canvas.showBoundingBox=!this.canvas.showBoundingBox;
			repaint();		// repaint this applet
			canvas.repaint();	// also repaint the canvas
		}
	}

}
