package Jcg.viewer.editor2d;

import Jcg.geometry.Point_2;
import Jcg.graph.GeometricGraph_2;

/**
 * Simple class for visualizing planar graphs and plane objects (points, segments, ...)
 * 
 * @author Luca Castelli Aleardi, Ecole Polytechnique (INF562)
 * @version dec 2012
 */
public class CylindricalCanvas2D extends Canvas2D {
	
	CylindricalCanvas2D() {
		super();
		this.p1=new Point_2(-Math.PI*2,-10.);
		this.p2=new Point_2(Math.PI*4,10.);
		this.epsilon=this.p1.distanceFrom(this.p2).doubleValue()/(100);
	}
	
	/**
	 * Restore initial configuration (data are deleted)
	 */
	public void restore() {
		super.restore();
		this.p1=new Point_2(-Math.PI*2,-10.);
		this.p2=new Point_2(Math.PI*4,10.);
		this.epsilon=this.p1.distanceFrom(this.p2).doubleValue()/(100);
		this.repaint();
	}

}
