package Jcg.viewer.editor2d;

import java.awt.Menu;
import java.awt.MenuItem;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import Jcg.mesh.SharedVertexRepresentation;

/**
 * Class defining menu for dealing with files
 * 
 * @author Luca Castelli Aleardi, Ecole Polytechnique (INF562)
 * @version dec 2012
 *
 */
class FileMenu extends Menu implements ActionListener { 
	  Editor2D editor;  
	  
	  public FileMenu(Editor2D m) { 
		  super("File"); 
		  editor = m; 
		  MenuItem itemNew, itemPointCloud, itemExit, itemGraph, itemPlanarMap, itemTriangleMesh; 
		  add(itemNew = new MenuItem("New")); 
		  itemNew.addActionListener(this); 
		  add(itemPointCloud = new MenuItem("Import point cloud")); 
		  itemPointCloud.addActionListener(this); 
		  add(itemGraph = new MenuItem("Import graph")); 
		  itemGraph.addActionListener(this); 
		  add(itemPlanarMap = new MenuItem("Import planar map")); 
		  itemPlanarMap.addActionListener(this); 
		  add(itemTriangleMesh = new MenuItem("Import triangle mesh")); 
		  itemTriangleMesh.addActionListener(this); 
		  add(itemExit = new MenuItem("Exit")); 
		  itemExit.addActionListener(this); 
	  } 
	 
	  public void actionPerformed(ActionEvent e) { 
		  String item = e.getActionCommand(); 
		  if (item.equals("Exit"))  
			  editor.exit(); 
		  if (item.equals("New")) {
			  System.out.println("Reset all data");
			  this.editor.canvas.restore();
		  }

		  if (item.equals("Import point cloud")) { 
			  AWTFileDialog filedialog=new AWTFileDialog();
			  String filename=filedialog.openFile("Open file", "current", "off");
			  SharedVertexRepresentation svr=new SharedVertexRepresentation(filename);
		  }
		  else  
			  System.out.println("Selected FileMenu " + item); 
	  }
	  
} 
