package Jcg.viewer.processing2d;

import Jcg.geometry.Point_2;

import java.awt.Color;
import java.awt.Point;
import java.util.LinkedList;

/**
 * @author Luca Castelli Aleardi
 *
 */
public class Draw2DProcessing {

	Canvas2DProcessing frame; // drawing frame (based on Processing)
	Point_2 a,b; // coordinates of the window

	
	public Draw2DProcessing(Canvas2DProcessing frame) {
		this.frame=frame;
		this.a=new Point_2(0., 0.);
		this.b=new Point_2(1., 0.);
	}
	
	/**
	 * Draw a segment between two points (in the given frame)
	 */
	public void drawSegment(Point_2 p, Point_2 q) {
		//this.frame.line((float)p.getX().doubleValue(), (float)p.getY().doubleValue(), (float)q.getX().doubleValue(), (float)q.getY().doubleValue());
		Point pI=this.getPoint(p);
		Point qI=this.getPoint(q);
		
		this.frame.line(pI.x, this.frame.height-pI.y, qI.x, this.frame.height-qI.y);

	}
	
	/**
	 * Draw a circle at given location in the frame
	 */
	public void drawPoint(Point_2 p) {
		this.frame.ellipse((float)p.getX().doubleValue(), (float)p.getY().doubleValue(), 5, 5);
	}
	
	public Point getPoint(Point_2 v) {
		double x=v.getX().doubleValue();
		double y=v.getY().doubleValue();
		int i= (int) (frame.width*( (x-a.getX().doubleValue()) / (b.getX().doubleValue()-a.getX().doubleValue()) ));
		int j= (int) (frame.height*( (y-a.getY().doubleValue()) / (b.getY().doubleValue()-a.getY().doubleValue()) ));
		
		return new Point(i,j);
	}

	
}
